#define BI_RGB      0L
#define BI_RLE8     1L
#define BI_RLE4     2L

typedef struct tagBITMAPFILEHEADER
{
    UINT    bfType;				   //	2
    DWORD   bfSize;				   //	4
    UINT    bfReserved1;		   //	2
    UINT    bfReserved2;		   //	2
    DWORD   bfOffBits;			   //	4
} __attribute__ ((packed)) BITMAPFILEHEADER;				   //	14

typedef struct tagBITMAPINFOHEADER
{
    DWORD   biSize;				   //	4
    LONG    biWidth;			   //	4
    LONG    biHeight;			   //	4
    WORD    biPlanes;			   //	2
    WORD    biBitCount;			   //	2
    DWORD   biCompression;		   //	4
    DWORD   biSizeImage;		   //	4
    LONG    biXPelsPerMeter;	   //	4
    LONG    biYPelsPerMeter;	   //	4
	  DWORD   biClrUsed;			   //	4
    DWORD   biClrImportant;		   //	4
} __attribute__ ((packed)) BITMAPINFOHEADER;				   //	40

typedef struct tagRGBQUAD
{
    UBYTE    rgbBlue;
    UBYTE    rgbGreen;
    UBYTE    rgbRed;
    UBYTE    rgbReserved;
} __attribute__ ((packed)) RGBQUAD;
