extern int agcd(int a,int b);
extern void FreeCommonStructures();
extern void InitCommonStructures();
extern void DOSTranslate(char *q,char *p);
extern void DOSUnTranslate(char *q,char *p);
extern char *Str8(char *buff);
extern int LevelNumber(char *levtag);
extern int IsD1Map(char *mname);
extern int IsD2Map(char *mname);
extern int IsDMap(char *mname);
extern void PrintVTex(FILE *st,VTex *mt,int i);
extern void PrintVTexList(FILE *st,VTex *mt,int mtcnt,char *secname);
extern void AddVTex(VTex **dt,int *n,int isp,char *nam,char *pth,char *sgn,int nargs,char **args);
extern void AddVT(VTex **dt,int *n,VTex *data);
extern void AddVTex2Num(VTex **dt,int *n,int isp,char *nam,char *pth,char *sgn,int num1,int num2);
extern int IsInVTexN(char *nam,VTex *list,int len,int n);
extern int IsInVTex(char *nam,VTex *list,int len);
extern void PutVTex(VTex **dt,int *n,int isp,char *nam,char *pth,char *sgn,int nargs,char **args);
extern int AddNewVTex(VTex **dt,int *n,int isp,char *nam,char *pth,char *sgn,int nargs,char **args);
extern int AddNewVT(VTex **dt,int *n,VTex *data);
extern int AddNewVTex2Num(VTex **dt,int *n,int isp,char *nam,char *pth,char *sgn,int num1,int num2);
extern void FreeVTex(void);
extern void InitVTex(void);
extern int filelen(FILE *st);
extern void AddDynStr(char ***dynstrp,int *ndynstr,char *str);
extern void FreeDynStr(char ***dynstrp,int *ndynstr);
extern void AddDynInt(int **dynintp,int *n,int val);
extern void AddDynShort(short **dynintp,int *n,short val);
extern int AddNewDynShort(short **dynintp,int *n,short val);
extern void DelDynInt(int **dynintp,int *n,int idx);
extern int AddNewDynInt(int **dynintp,int *n,int val);
extern void FreeDynInt(int **dynintp,int *n);
extern void FreeDynShort(short **dynintp,int *n);
extern void CopyEnvironmentCLArgs(char *envar,int arc,char **arv);
extern int ParseCommandLine(int maxopts,int maxfiles);
extern int ParseSlashOptionLine(int maxopts,int maxfiles);
extern void heap_dump(void );
extern int NextPowerTwo(int n);
extern int Tokenize(char *str,char *dlm,char ***dynstrp,int *ndynstr);
extern int TokenizeN(char *str,char *dlm,char ***dynstrp,int *ndynstr,int n);
extern void ConvertMarker(char *resn);
extern int GetKey(void );
extern int WaitKey(void);
extern void GetString(char *buffer);
extern int GetDEMO1Version(char *bwadname);
extern void SafeWrite(const void *buffer,int siz,int n,FILE *st);
extern char *stringf(char *fmt,... );
extern int MoveFile(char *srcp,char *dstp,int mv);
extern char *GetStringElt(StringArray *sa,int n);
extern int BStringEltFind(StringArray *sa,int strt,int end,char *theString);
extern int BStringFind(StringArray *sa,char *theString);
extern int StringFind(StringArray *sa,char *theString);
extern int ExistStringElt(StringArray *sa,char *theString,int *n);
extern int IsStringEltEqual(StringArray *sa,int n,char *theString);
extern void PutStringElt(StringArray *sa,int n,char *theString);
extern void AddStringSorted(StringArray *sa,char *theString);
extern void AppendStringElt(StringArray *sa,char *theString);
extern void FreeStringArray(StringArray *sa);
extern void InitStringArray(StringArray *sa,int len);
extern char *DOSName(char *inname);
extern int NLevObj();
extern void setweights(int r,int g,int b);
extern int colordist(RGBQUAD *col1,RGBQUAD *col2);
extern int dprintf(FILE *logfile,char *fmt,...);
extern int aprintf(char *fmt,...);
extern void FreeCLStrs();
extern void InitCLStrs();
extern void FreeSegs(Segment **segp,int *nsegp);
extern int CloseStreams();
extern void InitStreams(void);
extern int NumsOnly(char *str);
extern int IsNumeric(char *str);
extern int MoveFile(char *srcp, char *dstp,int mv);
extern void FreeLevelData();
extern int VertUsed(int vn);
extern void InitLevelData();
extern int ReadLevelData(char *maptag, WadDir *dir, FILE *st, int nlevobj);
extern void GetMapLimits();
extern int dostics();
extern void InitTics();
extern void StartTicTimer(int tid,int val,int mod);
extern int CheckTicTimer(int tid);
extern int DeltaTicTimer(int tid);
extern void StopTicTimer(int tid);
extern unsigned short *BlockmapPtr(int col, int row);
extern int BlockmapValid();
extern int IsInBox(int x,int y,int x1,int y1,int x2,int y2);
extern char *LineFlagStr(int attr);
extern char *ShortLineFlagStr(int attr);
extern void ResetBlockmapValid();
extern char *stristr(char *str1,char *str2);
extern void InitSegs(Segment **segp,int *nsegp);
extern int Intersect(short *xy,short *zw);
extern void MatchPalettes(RGBQUAD *curpal,RGBQUAD *outpal,int *lookup);

//rsubs
extern int IsColTranMap(char *name,WadDir *wdir,ResourceDefinition *rd);
extern int ListResMaps(char ***maplist,int *nmaps,WadDir *dir,ResourceDefinition *rd);
extern void AddColorTranMaps(char *wadname,WadDir *wdir,FILE *st);
extern void FreeColorTranMaps();

//lsubs
extern int ListMaps(char ***maplist,int *nmaps,WadDir *dir);
extern int linelen(int lineno);
extern int uprhgt(int sideno,int lineno,int *t);
extern int no1hgt(int sideno,int lineno,int *t);
extern int no2hgt(int sideno,int lineno,int *t);
extern int lwrhgt(int sideno,int lineno,int *t);
extern int CheckMedusa(TextureLump *tl,int tn,int sn,int ln,int hgt);
extern int AddThing(short x,short y,short ang,unsh typ,unsh attr);
extern int AddLinedef(unsh from,unsh to,unsh attr,unsh typ,unsh tag,short side0,short side1);
extern int AddSidedef(short xoff,short yoff,char *utxt,char *ltxt,char *ntxt,unsh sect);
extern int AddNewVertex(short x,short y);
extern int AddVertex(short x,short y);
extern int AddSeg(unsh from,unsh to,unsh ang,unsh ldef,unsh dir,unsh offs);
extern int AddSsector(unsh nsegs,unsh seg0);
extern int AddSector(short fhgt,short chgt,char *ftxt,char *ctxt,unsh lite,unsh typ,unsh tag);
extern int AddNode(short x,short y,short dx,short dy,
                   short lmxy,short lmny,short lmnx,short lmxx,
						       short rmxy,short rmny,short rmnx,short rmxx,
						       unsh child0,unsh child1);
extern void DumpSeg(unsh segnum);
extern void DumpSegs();
extern char *FormatSeg(Seg *sg);
extern void DumpSsector(unsh subsecnum);
extern void DumpSsectors();
extern void DumpNode(unsh nodenum);
extern void DumpNodes();
extern void BuildBlockmap();
extern void BuildZeroReject();
extern void WriteLevelWad(char *filename,char *maptag);
extern void *IsLevelResource(char *resname,int *size);
extern int TackLevelToWad(char *levname,char *maptag);
extern int CompactWad(char *name,FILE *pst,WadHeader *phdr,WadDir *pdir);
extern int WriteTotalWad(char *name,FILE *pst,WadHeader *phdr,WadDir *pdir,char *levname);
extern void WriteOpenLevelWad(FILE *pst,WadHeader *whdr,WadDir *wdir,char *maptag);
extern void PrintVertex(Vertex v);
extern void BuildReject();

